diff --git a/usr.bin/sdpquery/search.c b/usr.sbin/sdpcontrol/search.c
similarity index 77%
rename from usr.bin/sdpquery/search.c
rename to usr.sbin/sdpcontrol/search.c
index 7b75ade2da..3463586935 100644
--- a/usr.bin/sdpquery/search.c
+++ b/usr.sbin/sdpcontrol/search.c
@@ -1,34 +1,3 @@
-/* $NetBSD: search.c,v 1.6 2007/11/06 21:35:52 plunky Exp $ */
-/* $DragonFly: src/usr.bin/sdpquery/search.c,v 1.2 2008/02/11 20:09:42 swildner Exp $ */
-
-/*-
- * Copyright (c) 2006 Itronix Inc.
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. The name of Itronix Inc. may not be used to endorse
- *    or promote products derived from this software without specific
- *    prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY ITRONIX INC. ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
- * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
- * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL ITRONIX INC. BE LIABLE FOR ANY
- * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
- * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
 /*
  * search.c
  *
@@ -56,20 +25,17 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: search.c,v 1.6 2007/11/06 21:35:52 plunky Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpcontrol/search.c,v 1.4 2005/05/27 19:11:33 emax Exp $
+ * $Id: search.c,v 1.2 2003/09/08 17:35:15 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpcontrol/search.c 173335 2007-11-04 21:24:33Z emax $
  */
 
 #include <netinet/in.h>
 #include <bluetooth.h>
-#include <err.h>
-#include <errno.h>
 #include <ctype.h>
 #include <sdp.h>
 #include <stdio.h>
 #include <stdlib.h>
-
-#include "sdpquery.h"
+#include "sdpcontrol.h"
 
 /* List of the attributes we are looking for */
 static uint32_t	attrs[] =
@@ -97,9 +63,9 @@ static sdp_attr_t	values[NRECS * attrs_len];
 /*
  * Print Service Class ID List
  *
- * The ServiceClassIDList attribute consists of a data element sequence in
+ * The ServiceClassIDList attribute consists of a data element sequence in 
  * which each data element is a UUID representing the service classes that
- * a given service record conforms to. The UUIDs are listed in order from
+ * a given service record conforms to. The UUIDs are listed in order from 
  * the most specific class to the most general class. The ServiceClassIDList
  * must contain at least one service class UUID.
  */
@@ -175,15 +141,15 @@ print_service_class_id_list(uint8_t const *start, uint8_t const *end)
 /*
  * Print Protocol Descriptor List
  *
- * If the ProtocolDescriptorList describes a single stack, it takes the form
- * of a data element sequence in which each element of the sequence is a
- * protocol descriptor. Each protocol descriptor is, in turn, a data element
- * sequence whose first element is a UUID identifying the protocol and whose
- * successive elements are protocol-specific parameters. The protocol
- * descriptors are listed in order from the lowest layer protocol to the
+ * If the ProtocolDescriptorList describes a single stack, it takes the form 
+ * of a data element sequence in which each element of the sequence is a 
+ * protocol descriptor. Each protocol descriptor is, in turn, a data element 
+ * sequence whose first element is a UUID identifying the protocol and whose 
+ * successive elements are protocol-specific parameters. The protocol 
+ * descriptors are listed in order from the lowest layer protocol to the 
  * highest layer protocol used to gain access to the service. If it is possible
- * for more than one kind of protocol stack to be used to gain access to the
- * service, the ProtocolDescriptorList takes the form of a data element
+ * for more than one kind of protocol stack to be used to gain access to the 
+ * service, the ProtocolDescriptorList takes the form of a data element 
  * alternative where each member is a data element sequence as described above.
  */
 
@@ -292,21 +258,21 @@ print_protocol_descriptor(uint8_t const *start, uint8_t const *end)
 		case SDP_DATA_STR8:
 		case SDP_DATA_URL8:
 			SDP_GET8(len, start);
-			fprintf(stdout, "%*.*s\n", len, len,  start);
+			fprintf(stdout, "%*.*s\n", len, len, (char *) start);
 			start += len;
 			break;
 
 		case SDP_DATA_STR16:
 		case SDP_DATA_URL16:
 			SDP_GET16(len, start);
-			fprintf(stdout, "%*.*s\n", len, len,  start);
+			fprintf(stdout, "%*.*s\n", len, len, (char *) start);
 			start += len;
 			break;
 
 		case SDP_DATA_STR32:
 		case SDP_DATA_URL32:
 			SDP_GET32(len, start);
-			fprintf(stdout, "%*.*s\n", len, len,  start);
+			fprintf(stdout, "%*.*s\n", len, len, (char *) start);
 			start += len;
 			break;
 
@@ -405,15 +371,15 @@ print_protocol_descriptor_list(uint8_t const *start, uint8_t const *end)
 /*
  * Print Bluetooth Profile Descriptor List
  *
- * The BluetoothProfileDescriptorList attribute consists of a data element
- * sequence in which each element is a profile descriptor that contains
- * information about a Bluetooth profile to which the service represented by
- * this service record conforms. Each profile descriptor is a data element
- * sequence whose first element is the UUID assigned to the profile and whose
+ * The BluetoothProfileDescriptorList attribute consists of a data element 
+ * sequence in which each element is a profile descriptor that contains 
+ * information about a Bluetooth profile to which the service represented by 
+ * this service record conforms. Each profile descriptor is a data element 
+ * sequence whose first element is the UUID assigned to the profile and whose 
  * second element is a 16-bit profile version number. Each version of a profile
  * is assigned a 16-bit unsigned integer profile version number, which consists
- * of two 8-bit fields. The higher-order 8 bits contain the major version
- * number field and the lower-order 8 bits contain the minor version number
+ * of two 8-bit fields. The higher-order 8 bits contain the major version 
+ * number field and the lower-order 8 bits contain the minor version number 
  * field.
  */
 
@@ -522,67 +488,102 @@ print_bluetooth_profile_descriptor_list(uint8_t const *start, uint8_t const *end
 	}
 } /* print_bluetooth_profile_descriptor_list */
 
-struct service {
-	const char	*name;
-	uint16_t	class;
-	const char	*description;
-} services[] = {
-	{ "CIP",	SDP_SERVICE_CLASS_COMMON_ISDN_ACCESS,
-	  "Common ISDN Access"		},
-	{ "CTP",	SDP_SERVICE_CLASS_CORDLESS_TELEPHONY,
-	  "Cordless Telephony"		},
-	{ "DUN",	SDP_SERVICE_CLASS_DIALUP_NETWORKING,
-	  "Dial Up Networking"		},
-	{ "FAX",	SDP_SERVICE_CLASS_FAX,
-	  "Fax"				},
-	{ "FTRN",	SDP_SERVICE_CLASS_OBEX_FILE_TRANSFER,
-	  "Obex File Transfer"		},
-	{ "GN",		SDP_SERVICE_CLASS_GN,
-	  "Group ad-hoc Network"	},
-	{ "HID",	SDP_SERVICE_CLASS_HUMAN_INTERFACE_DEVICE,
-	  "Human Interface Device"	},
-	{ "HF",		SDP_SERVICE_CLASS_HANDSFREE,
-	  "Handsfree"			},
-	{ "HSET",	SDP_SERVICE_CLASS_HEADSET,
-	  "Headset"			},
-	{ "LAN",	SDP_SERVICE_CLASS_LAN_ACCESS_USING_PPP,
-	  "Lan access using PPP"	},
-	{ "NAP",	SDP_SERVICE_CLASS_NAP,
-	  "Network Access Point"	},
-	{ "OPUSH",	SDP_SERVICE_CLASS_OBEX_OBJECT_PUSH,
-	  "OBEX Object Push"		},
-	{ "PANU",	SDP_SERVICE_CLASS_PANU,
-	  "Personal Area Networking User"		},
-	{ "SP",		SDP_SERVICE_CLASS_SERIAL_PORT,
-	  "Serial Port"			},
-	{ NULL,		0,
-	  NULL				}
-};
-
 /* Perform SDP search command */
-int
-do_sdp_search(bdaddr_t *laddr, bdaddr_t *raddr, int argc, char const **argv)
+static int
+do_sdp_search(void *xs, int argc, char **argv)
 {
-	struct service	*s;
-	void		*xs;
-	char		*ep;
-	uint32_t	 n;
-	int32_t		 type, value;
+	char		*ep = NULL;
+	int32_t		 n, type, value;
 	uint16_t	 service;
 
-	if (argc != 1)
-		goto usage;
+	/* Parse command line arguments */
+	switch (argc) {
+	case 1:
+		n = strtoul(argv[0], &ep, 16);
+		if (*ep != 0) {
+			switch (tolower(argv[0][0])) {
+			case 'c': /* CIP/CTP */
+				switch (tolower(argv[0][1])) {
+				case 'i':
+					service = SDP_SERVICE_CLASS_COMMON_ISDN_ACCESS;
+					break;
+
+				case 't':
+					service = SDP_SERVICE_CLASS_CORDLESS_TELEPHONY;
+					break;
+
+				default:
+					return (USAGE);
+					/* NOT REACHED */
+				}
+				break;
 
-	service = strtoul(*argv, &ep, 16);
-	if (*ep != 0) {
-		for (s = services ; ; s++) {
-			if (s->name == NULL)
-				goto usage;
+			case 'd': /* DialUp Networking */
+				service = SDP_SERVICE_CLASS_DIALUP_NETWORKING;
+				break;
 
-			if (strcasecmp(s->name, *argv) == 0)
+			case 'f': /* Fax/OBEX File Transfer */
+				switch (tolower(argv[0][1])) {
+				case 'a':
+					service = SDP_SERVICE_CLASS_FAX;
+					break;
+
+				case 't':
+					service = SDP_SERVICE_CLASS_OBEX_FILE_TRANSFER;
+					break;
+
+				default:
+					return (USAGE);
+					/* NOT REACHED */
+				}
 				break;
-		}
-		service = s->class;
+
+			case 'g': /* GN */
+				service = SDP_SERVICE_CLASS_GN;
+				break;
+
+			case 'h': /* Headset/HID */
+				switch (tolower(argv[0][1])) {
+				case 'i':
+					service = SDP_SERVICE_CLASS_HUMAN_INTERFACE_DEVICE;
+					break;
+
+				case 's':
+					service = SDP_SERVICE_CLASS_HEADSET;
+					break;
+
+				default:
+					return (USAGE);
+					/* NOT REACHED */
+				}
+				break;
+
+			case 'l': /* LAN Access Using PPP */
+				service = SDP_SERVICE_CLASS_LAN_ACCESS_USING_PPP;
+				break;
+
+			case 'n': /* NAP */
+				service = SDP_SERVICE_CLASS_NAP;
+				break;
+
+			case 'o': /* OBEX Object Push */
+				service = SDP_SERVICE_CLASS_OBEX_OBJECT_PUSH;
+				break;
+
+			case 's': /* Serial Port */
+				service = SDP_SERVICE_CLASS_SERIAL_PORT;
+				break;
+
+			default:
+				return (USAGE);
+				/* NOT REACHED */
+			}
+		} else
+			service = (uint16_t) n;
+		break;
+
+	default:
+		return (USAGE);
 	}
 
 	/* Initialize attribute values array */
@@ -593,20 +594,10 @@ do_sdp_search(bdaddr_t *laddr, bdaddr_t *raddr, int argc, char const **argv)
 		values[n].value = buffer[n];
 	}
 
-	if (bdaddr_any(raddr))
-		xs = sdp_open_local(control_socket);
-	else
-		xs = sdp_open(laddr, raddr);
-
-	if (xs == NULL || (errno = sdp_error(xs)) != 0)
-		err(EXIT_FAILURE, "sdp_open");
-
 	/* Do SDP Service Search Attribute Request */
 	n = sdp_search(xs, 1, &service, attrs_len, attrs, values_len, values);
 	if (n != 0)
-		err(EXIT_FAILURE, "sdp_search");
-
-	sdp_close(xs);
+		return (ERROR);
 
 	/* Print attributes values */
 	for (n = 0; n < values_len; n ++) {
@@ -657,38 +648,66 @@ do_sdp_search(bdaddr_t *laddr, bdaddr_t *raddr, int argc, char const **argv)
 		}
 	}
 
-	return EXIT_SUCCESS;
-
-usage:
-	fprintf(stderr, "Known services:\n");
-	for (s = services ; s->name != NULL ; s++)
-		fprintf(stderr, "\t%s\t%s\n", s->name, s->description);
-
-	return EXIT_FAILURE;
+	return (OK);
 } /* do_sdp_search */
 
 /* Perform SDP browse command */
-int
-do_sdp_browse(bdaddr_t *laddr, bdaddr_t *raddr, int argc, char const **argv)
+static int
+do_sdp_browse(void *xs, int argc, char **argv)
 {
 #undef	_STR
 #undef	STR
 #define	_STR(x)	#x
 #define	STR(x)	_STR(x)
 
-	static char	const * av[] = {
+	static char const * const	av[] = {
 		STR(SDP_SERVICE_CLASS_PUBLIC_BROWSE_GROUP),
 		NULL
-	};
+	}; 
 
 	switch (argc) {
 	case 0:
 		argc = 1;
-		argv =  (char const **) av;
+		argv = (char **) av;
 		/* FALL THROUGH */
 	case 1:
-		return (do_sdp_search(laddr, raddr, argc, argv));
+		return (do_sdp_search(xs, argc, argv));
 	}
 
-	return EXIT_FAILURE;
+	return (USAGE);
 } /* do_sdp_browse */
+
+/* List of SDP commands */
+struct sdp_command	sdp_commands[] = {
+{
+"Browse [<Group>]",
+"Browse for services. The <Group> parameter is a 16-bit UUID of the group\n" \
+"to browse. If omitted <Group> is set to Public Browse Group.\n\n" \
+"\t<Group> - xxxx; 16-bit UUID of the group to browse\n",
+do_sdp_browse
+},
+{
+"Search <Service>",
+"Search for the <Service>. The <Service> parameter is a 16-bit UUID of the\n" \
+"service to search for. For some services it is possible to use service name\n"\
+"instead of service UUID\n\n" \
+"\t<Service> - xxxx; 16-bit UUID of the service to search for\n\n" \
+"\tKnown service names\n" \
+"\t===================\n" \
+"\tCIP   - Common ISDN Access\n" \
+"\tCTP   - Cordless Telephony\n" \
+"\tDUN   - DialUp Networking\n" \
+"\tFAX   - Fax\n" \
+"\tFTRN  - OBEX File Transfer\n" \
+"\tGN    - GN\n" \
+"\tHID   - Human Interface Device\n" \
+"\tHSET  - Headset\n" \
+"\tLAN   - LAN Access Using PPP\n" \
+"\tNAP   - Network Access Point\n" \
+"\tOPUSH - OBEX Object Push\n" \
+"\tSP    - Serial Port\n",
+do_sdp_search
+},
+{ NULL, NULL, NULL }
+};
+
diff --git a/usr.sbin/sdpd/Makefile b/usr.sbin/sdpd/Makefile
index 862f011fd8..086929db64 100644
--- a/usr.sbin/sdpd/Makefile
+++ b/usr.sbin/sdpd/Makefile
@@ -1,12 +1,13 @@
-# $NetBSD: Makefile,v 1.3 2007/05/28 12:06:41 tls Exp $
+# $Id: Makefile,v 1.1 2004/01/20 21:27:55 max Exp $
+# $FreeBSD: head/usr.sbin/bluetooth/sdpd/Makefile 177059 2008-03-11 16:51:07Z emax $
 
 PROG=		sdpd
 MAN=		sdpd.8
-SRCS=		bgd.c dun.c ftrn.c hf.c hset.c irmc.c irmc_command.c lan.c \
-		log.c main.c opush.c profile.c provider.c sar.c scr.c \
+SRCS=		bgd.c dun.c ftrn.c gn.c irmc.c irmc_command.c lan.c log.c \
+		main.c nap.c opush.c panu.c profile.c provider.c sar.c scr.c \
 		sd.c server.c sp.c srr.c ssar.c ssr.c sur.c uuid.c
-WARNS?=		2
 
-CFLAGS+=	-I${.CURDIR}/../../sys
+CFLAGS+=	-I${.CURDIR}
+WARNS?=		2
 
 .include <bsd.prog.mk>
diff --git a/usr.sbin/sdpd/bgd.c b/usr.sbin/sdpd/bgd.c
index a9cc7f5915..6d96c4d895 100644
--- a/usr.sbin/sdpd/bgd.c
+++ b/usr.sbin/sdpd/bgd.c
@@ -1,5 +1,3 @@
-/* $NetBSD: bgd.c,v 1.2 2007/11/09 20:08:40 plunky Exp $ */
-
 /*
  * bgd.c
  *
@@ -27,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: bgd.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/bgd.c,v 1.1 2004/01/20 20:48:26 emax Exp $
+ * $Id: bgd.c,v 1.4 2004/01/13 01:54:39 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/bgd.c 124758 2004-01-20 20:48:26Z emax $
  */
 
 #include <bluetooth.h>
@@ -84,9 +82,9 @@ static attr_t	bgd_profile_attrs[] = {
 	  bgd_profile_create_service_class_id_list },
 	{ SDP_ATTR_LANGUAGE_BASE_ATTRIBUTE_ID_LIST,
 	  common_profile_create_language_base_attribute_id_list },
-	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_SERVICE_NAME_OFFSET,
+	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_SERVICE_NAME_OFFSET, 
 	  bgd_profile_create_service_name },
-	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_SERVICE_DESCRIPTION_OFFSET,
+	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_SERVICE_DESCRIPTION_OFFSET, 
 	  bgd_profile_create_service_name },
 	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_PROVIDER_NAME_OFFSET,
 	  common_profile_create_service_provider_name },
@@ -95,14 +93,10 @@ static attr_t	bgd_profile_attrs[] = {
 	{ 0, NULL } /* end entry */
 };
 
-static uint16_t	bgd_profile_uuids[] = {
-	SDP_SERVICE_CLASS_BROWSE_GROUP_DESCRIPTOR,
-};
-
 profile_t	bgd_profile_descriptor = {
-	bgd_profile_uuids,
-	sizeof(bgd_profile_uuids),
+	SDP_SERVICE_CLASS_BROWSE_GROUP_DESCRIPTOR,
 	0,
-	NULL,
+	(profile_data_valid_p) NULL,
 	(attr_t const * const) &bgd_profile_attrs
 };
+
diff --git a/usr.sbin/sdpd/dun.c b/usr.sbin/sdpd/dun.c
index 980b66c550..f2f2d7414b 100644
--- a/usr.sbin/sdpd/dun.c
+++ b/usr.sbin/sdpd/dun.c
@@ -1,6 +1,3 @@
-/* $NetBSD: dun.c,v 1.2 2007/11/09 20:08:40 plunky Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/dun.c,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * dun.c
  *
@@ -28,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: dun.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/dun.c,v 1.1 2004/01/20 20:48:26 emax Exp $
+ * $Id: dun.c,v 1.5 2004/01/13 01:54:39 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/dun.c 124758 2004-01-20 20:48:26Z emax $
  */
 
 #include <sys/queue.h>
@@ -87,12 +84,12 @@ dun_profile_create_protocol_descriptor_list(
 		uint8_t *buf, uint8_t const * const eob,
 		uint8_t const *data, uint32_t datalen)
 {
-	provider_t const	*provider = (provider_t const *) data;
+	provider_p		provider = (provider_p) data;
 	sdp_dun_profile_p	dun = (sdp_dun_profile_p) provider->data;
 
 	return (rfcomm_profile_create_protocol_descriptor_list(
 			buf, eob,
-			(uint8_t const *) &dun->server_channel, 1));
+			(uint8_t const *) &dun->server_channel, 1)); 
 }
 
 static int32_t
@@ -100,7 +97,7 @@ dun_profile_create_audio_feedback_support(
 		uint8_t *buf, uint8_t const * const eob,
 		uint8_t const *data, uint32_t datalen)
 {
-	provider_t const	*provider = (provider_t const *) data;
+	provider_p		provider = (provider_p) data;
 	sdp_dun_profile_p	dun = (sdp_dun_profile_p) provider->data;
 
 	if (buf + 2 > eob)
@@ -121,7 +118,7 @@ static attr_t	dun_profile_attrs[] = {
 	  dun_profile_create_bluetooth_profile_descriptor_list },
 	{ SDP_ATTR_LANGUAGE_BASE_ATTRIBUTE_ID_LIST,
 	  common_profile_create_language_base_attribute_id_list },
-	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_SERVICE_NAME_OFFSET,
+	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_SERVICE_NAME_OFFSET, 
 	  dun_profile_create_service_name },
 	{ SDP_ATTR_PROTOCOL_DESCRIPTOR_LIST,
 	  dun_profile_create_protocol_descriptor_list },
@@ -130,17 +127,10 @@ static attr_t	dun_profile_attrs[] = {
 	{ 0, NULL } /* end entry */
 };
 
-static uint16_t dun_profile_uuids[] = {
-	SDP_SERVICE_CLASS_DIALUP_NETWORKING,
-	SDP_SERVICE_CLASS_GENERIC_NETWORKING,
-	SDP_UUID_PROTOCOL_L2CAP,
-	SDP_UUID_PROTOCOL_RFCOMM,
-};
-
 profile_t	dun_profile_descriptor = {
-	dun_profile_uuids,
-	sizeof(dun_profile_uuids),
+	SDP_SERVICE_CLASS_DIALUP_NETWORKING,
 	sizeof(sdp_dun_profile_t),
 	common_profile_server_channel_valid,
 	(attr_t const * const) &dun_profile_attrs
 };
+
diff --git a/usr.sbin/sdpd/ftrn.c b/usr.sbin/sdpd/ftrn.c
index 828efdfb72..59f27e6d22 100644
--- a/usr.sbin/sdpd/ftrn.c
+++ b/usr.sbin/sdpd/ftrn.c
@@ -1,6 +1,3 @@
-/* $NetBSD: ftrn.c,v 1.2 2007/11/09 20:08:40 plunky Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/ftrn.c,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * ftrn.c
  *
@@ -28,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: ftrn.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/ftrn.c,v 1.1 2004/01/20 20:48:26 emax Exp $
+ * $Id: ftrn.c,v 1.5 2004/01/13 01:54:39 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/ftrn.c 124758 2004-01-20 20:48:26Z emax $
  */
 
 #include <sys/queue.h>
@@ -87,12 +84,12 @@ ftrn_profile_create_protocol_descriptor_list(
 		uint8_t *buf, uint8_t const * const eob,
 		uint8_t const *data, uint32_t datalen)
 {
-	provider_t const	*provider = (provider_t const *) data;
+	provider_p		provider = (provider_p) data;
 	sdp_ftrn_profile_p	ftrn = (sdp_ftrn_profile_p) provider->data;
 
 	return (obex_profile_create_protocol_descriptor_list(
 			buf, eob,
-			(uint8_t const *) &ftrn->server_channel, 1));
+			(uint8_t const *) &ftrn->server_channel, 1)); 
 }
 
 static attr_t	ftrn_profile_attrs[] = {
@@ -111,17 +108,10 @@ static attr_t	ftrn_profile_attrs[] = {
 	{ 0, NULL } /* end entry */
 };
 
-static uint16_t ftrn_profile_uuids[] = {
-	SDP_SERVICE_CLASS_OBEX_FILE_TRANSFER,
-	SDP_UUID_PROTOCOL_L2CAP,
-	SDP_UUID_PROTOCOL_RFCOMM,
-	SDP_UUID_PROTOCOL_OBEX,
-};
-
 profile_t	ftrn_profile_descriptor = {
-	ftrn_profile_uuids,
-	sizeof(ftrn_profile_uuids),
+	SDP_SERVICE_CLASS_OBEX_FILE_TRANSFER,
 	sizeof(sdp_ftrn_profile_t),
 	common_profile_server_channel_valid,
 	(attr_t const * const) &ftrn_profile_attrs
 };
+
diff --git a/usr.sbin/sdpd/gn.c b/usr.sbin/sdpd/gn.c
new file mode 100644
index 0000000000..7e421c3446
--- /dev/null
+++ b/usr.sbin/sdpd/gn.c
@@ -0,0 +1,172 @@
+/*
+ * gn.c
+ */
+
+/*-
+ * Copyright (c) 2008 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: gn.c,v 1.1 2008/03/11 00:02:42 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/gn.c 177358 2008-03-18 18:21:39Z emax $
+ */
+
+#include <sys/queue.h>
+#include <bluetooth.h>
+#include <sdp.h>
+#include <string.h>
+#include "profile.h"
+#include "provider.h"
+
+static int32_t
+gn_profile_create_service_class_id_list(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	static uint16_t	service_classes[] = {
+		SDP_SERVICE_CLASS_GN
+	};
+
+	return (common_profile_create_service_class_id_list(
+			buf, eob,
+			(uint8_t const *) service_classes,
+			sizeof(service_classes)));
+}
+
+static int32_t
+gn_profile_create_bluetooth_profile_descriptor_list(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	static uint16_t	profile_descriptor_list[] = {
+		SDP_SERVICE_CLASS_GN,
+		0x0100
+	};
+
+	return (common_profile_create_bluetooth_profile_descriptor_list(
+			buf, eob,
+			(uint8_t const *) profile_descriptor_list,
+			sizeof(profile_descriptor_list)));
+}
+
+static int32_t
+gn_profile_create_service_name(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	static char	service_name[] = "Group Ad-hoc Network";
+
+	return (common_profile_create_string8(
+			buf, eob,
+			(uint8_t const *) service_name, strlen(service_name)));
+}
+
+static int32_t
+gn_profile_create_service_description(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	static char	service_descr[] =
+				"Personal Group Ad-hoc Network Service";
+
+	return (common_profile_create_string8(
+			buf, eob,
+			(uint8_t const *) service_descr,
+			strlen(service_descr)));
+}
+
+static int32_t
+gn_profile_create_protocol_descriptor_list(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	provider_p		provider = (provider_p) data;
+	sdp_gn_profile_p	gn = (sdp_gn_profile_p) provider->data;
+	
+	return (bnep_profile_create_protocol_descriptor_list(
+			buf, eob, (uint8_t const *) &gn->psm,
+			sizeof(gn->psm))); 
+}
+
+static int32_t
+gn_profile_create_security_description(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	provider_p		provider = (provider_p) data;
+	sdp_gn_profile_p	gn = (sdp_gn_profile_p) provider->data;
+
+	return (bnep_profile_create_security_description(buf, eob,
+			(uint8_t const *) &gn->security_description,
+			sizeof(gn->security_description)));
+}
+
+static int32_t
+gn_profile_create_service_availability(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	provider_p		provider = (provider_p) data;
+	sdp_gn_profile_p	gn = (sdp_gn_profile_p) provider->data;
+
+	return (common_profile_create_service_availability(buf, eob,
+			&gn->load_factor, 1));
+}
+
+static int32_t
+gn_profile_data_valid(uint8_t const *data, uint32_t datalen)
+{
+	sdp_gn_profile_p	gn = (sdp_gn_profile_p) data;
+
+	return ((gn->psm == 0)? 0 : 1);
+}
+
+static attr_t	gn_profile_attrs[] = {
+	{ SDP_ATTR_SERVICE_RECORD_HANDLE,
+	  common_profile_create_service_record_handle },
+	{ SDP_ATTR_SERVICE_CLASS_ID_LIST,
+	  gn_profile_create_service_class_id_list },
+	{ SDP_ATTR_PROTOCOL_DESCRIPTOR_LIST,
+	  gn_profile_create_protocol_descriptor_list },
+	{ SDP_ATTR_LANGUAGE_BASE_ATTRIBUTE_ID_LIST,
+	  common_profile_create_language_base_attribute_id_list },
+	{ SDP_ATTR_SERVICE_AVAILABILITY,
+	  gn_profile_create_service_availability },
+	{ SDP_ATTR_BLUETOOTH_PROFILE_DESCRIPTOR_LIST,
+	  gn_profile_create_bluetooth_profile_descriptor_list },
+	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_SERVICE_NAME_OFFSET, 
+	  gn_profile_create_service_name },
+	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_SERVICE_DESCRIPTION_OFFSET, 
+	  gn_profile_create_service_description },
+	{ SDP_ATTR_SECURITY_DESCRIPTION, 
+	  gn_profile_create_security_description },
+	{ 0, NULL } /* end entry */
+};
+
+profile_t	gn_profile_descriptor = {
+	SDP_SERVICE_CLASS_GN,
+	sizeof(sdp_gn_profile_t),
+	gn_profile_data_valid,
+	(attr_t const * const) &gn_profile_attrs
+};
+
diff --git a/usr.sbin/sdpd/irmc.c b/usr.sbin/sdpd/irmc.c
index 2b78887d49..3ade415ac8 100644
--- a/usr.sbin/sdpd/irmc.c
+++ b/usr.sbin/sdpd/irmc.c
@@ -1,6 +1,3 @@
-/* $NetBSD: irmc.c,v 1.2 2007/11/09 20:08:41 plunky Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/irmc.c,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * irmc.c
  *
@@ -28,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: irmc.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/irmc.c,v 1.1 2004/01/20 20:48:26 emax Exp $
+ * $Id: irmc.c,v 1.6 2004/01/13 19:31:54 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/irmc.c 124758 2004-01-20 20:48:26Z emax $
  */
 
 #include <sys/queue.h>
@@ -87,12 +84,12 @@ irmc_profile_create_protocol_descriptor_list(
 		uint8_t *buf, uint8_t const * const eob,
 		uint8_t const *data, uint32_t datalen)
 {
-	provider_t const	*provider = (provider_t const *) data;
+	provider_p		provider = (provider_p) data;
 	sdp_irmc_profile_p	irmc = (sdp_irmc_profile_p) provider->data;
 
 	return (obex_profile_create_protocol_descriptor_list(
 			buf, eob,
-			(uint8_t const *) &irmc->server_channel, 1));
+			(uint8_t const *) &irmc->server_channel, 1)); 
 }
 
 static int32_t
@@ -100,7 +97,7 @@ irmc_profile_create_supported_formats_list(
 		uint8_t *buf, uint8_t const * const eob,
 		uint8_t const *data, uint32_t datalen)
 {
-	provider_t const	*provider = (provider_t const *) data;
+	provider_p		provider = (provider_p) data;
 	sdp_irmc_profile_p	irmc = (sdp_irmc_profile_p) provider->data;
 
 	return (obex_profile_create_supported_formats_list(
@@ -127,17 +124,10 @@ static attr_t	irmc_profile_attrs[] = {
 	{ 0, NULL } /* end entry */
 };
 
-static uint16_t irmc_profile_uuids[] = {
-	SDP_SERVICE_CLASS_IR_MC_SYNC,
-	SDP_UUID_PROTOCOL_L2CAP,
-	SDP_UUID_PROTOCOL_RFCOMM,
-	SDP_UUID_PROTOCOL_OBEX,
-};
-
 profile_t	irmc_profile_descriptor = {
-	irmc_profile_uuids,
-	sizeof(irmc_profile_uuids),
+	SDP_SERVICE_CLASS_IR_MC_SYNC,
 	sizeof(sdp_irmc_profile_t),
 	obex_profile_data_valid,
 	(attr_t const * const) &irmc_profile_attrs
 };
+
diff --git a/usr.sbin/sdpd/irmc_command.c b/usr.sbin/sdpd/irmc_command.c
index 801bb19af8..62ef669ade 100644
--- a/usr.sbin/sdpd/irmc_command.c
+++ b/usr.sbin/sdpd/irmc_command.c
@@ -1,6 +1,3 @@
-/* $NetBSD: irmc_command.c,v 1.2 2007/11/09 20:08:41 plunky Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/irmc_command.c,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * irmc_command_command_command.c
  *
@@ -28,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: irmc_command.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/irmc_command.c,v 1.1 2004/01/20 20:48:26 emax Exp $
+ * $Id: irmc_command.c,v 1.5 2004/01/13 01:54:39 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/irmc_command.c 124758 2004-01-20 20:48:26Z emax $
  */
 
 #include <sys/queue.h>
@@ -87,12 +84,12 @@ irmc_command_profile_create_protocol_descriptor_list(
 		uint8_t *buf, uint8_t const * const eob,
 		uint8_t const *data, uint32_t datalen)
 {
-	provider_t const		*provider = (provider_t const *) data;
+	provider_p			provider = (provider_p) data;
 	sdp_irmc_command_profile_p	irmc_command = (sdp_irmc_command_profile_p) provider->data;
 
 	return (obex_profile_create_protocol_descriptor_list(
 			buf, eob,
-			(uint8_t const *) &irmc_command->server_channel, 1));
+			(uint8_t const *) &irmc_command->server_channel, 1)); 
 }
 
 static attr_t	irmc_command_profile_attrs[] = {
@@ -111,17 +108,10 @@ static attr_t	irmc_command_profile_attrs[] = {
 	{ 0, NULL } /* end entry */
 };
 
-static uint16_t	irmc_command_profile_uuids[] = {
-	SDP_SERVICE_CLASS_IR_MC_SYNC_COMMAND,
-	SDP_UUID_PROTOCOL_L2CAP,
-	SDP_UUID_PROTOCOL_RFCOMM,
-	SDP_UUID_PROTOCOL_OBEX,
-};
-
 profile_t	irmc_command_profile_descriptor = {
-	irmc_command_profile_uuids,
-	sizeof(irmc_command_profile_uuids),
+	SDP_SERVICE_CLASS_IR_MC_SYNC_COMMAND,
 	sizeof(sdp_irmc_command_profile_t),
 	common_profile_server_channel_valid,
 	(attr_t const * const) &irmc_command_profile_attrs
 };
+
